#include"NRF24L01.H"

sbit CE   =	P1^0;  	//RX/TXģʽѡ
sbit CSN  =	P1^1; 	//SPIƬѡ//SS
sbit MISO =	P1^2;	//SPIӻ
sbit MOSI =	P1^3;	//SPIӻ
sbit SCLK =	P1^4;	//SPIʱӶ
sbit IRQ  =	P3^2; 	//ж϶

uchar code TX_ADDRESS[5]  = {0xb4,0xb2,0xb3,0xb4,0x01};//·ɽڵַ2-5ͨʱĵһַ
uchar code RX_ADDRESS0[5] = {0x34,0x43,0x10,0x10,0x01};//дַĴдֽڣ˺漸ֽͬ
uchar code RX_ADDRESS1[5] = {0xb0,0xb2,0xb3,0xb4,0x01};//дַĴдֽڣ˺漸ֽͬ
uchar code RX_ADDRESS2[1] = {0xb1};
uchar code RX_ADDRESS3[1] = {0xb2};
uchar code RX_ADDRESS4[1] = {0xb3};
uchar code RX_ADDRESS5[1] = {0xb4};
uchar  sta;
/*****************״̬־*****************************************/
#define MAX_RT  	0x10  //ﵽʹж
#define TX_DS   	0x20  //TXж
#define RX_DR   	0x40  //յж
void Delay(uint t)
{
  uint x,y;
  for(x=t;x>0;x--)
   for(y=110;y>0;y--);
}
/*****************SPIʱ******************************************/
uchar NRFSPI(uchar date)
{
    uchar i;
   	for(i=0;i<8;i++)          // ѭ8
   	{
	  if(date&0x80)
	    MOSI=1;
	  else
	    MOSI=0;   // byteλMOSI
   	  date<<=1;             // һλλλ
   	  SCLK=1; 
	  if(MISO)               // SCKnRF24L01MOSI1λݣͬʱMISO1λ
   	    date|=0x01;       	// MISObyteλ
   	  SCLK=0;            	// SCKõ
   	}
    return(date);           	// ضһֽ
}
/**********************NRF24L01ʼ*******************************/
void NRF24L01Int()
{
	Delay(2);//ϵͳʲô
	CE=0; //ģʽ1   
	CSN=1;  
	SCLK=0;
	IRQ=1;	 
}
//24L01Ƿ
//ֵ:0ɹ;1ʧ	
uchar NRF24L01_Check(void)
{
	uchar buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	uchar i;
	NRFWriteTxDate(W_REGISTER+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	NRFReadRxDate(TX_ADDR,buf,5); //дĵַ  
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;	 							   
	if(i!=5)return 1;//24L01	
	return 0;		 //⵽24L01
}

/*****************SPIĴһֽں*********************************/
uchar NRFReadReg(uchar RegAddr)
{
   uchar BackDate;
   CSN=0;//ʱ
   NRFSPI(RegAddr);//дĴַ
   BackDate=NRFSPI(0xff);//дĴָ  
   CSN=1;
   return(BackDate); //״̬
}
/*****************SPIдĴһֽں*********************************/
uchar NRFWriteReg(uchar RegAddr,uchar date)
{
   uchar BackDate;
   CSN=0;//ʱ
   BackDate=NRFSPI(RegAddr);//дַ
   NRFSPI(date);//дֵ
   CSN=1;
   return(BackDate);
}
/*****************SPIȡRXFIFOĴֵ********************************/
uchar NRFReadRxDate(uchar RegAddr,uchar *RxDate,uchar DateLen)
{  //Ĵַ//ȡݴű//ȡݳ
    uchar BackDate,i;
	CSN=0;//ʱ
	BackDate=NRFSPI(RegAddr);//дҪȡļĴַ
	for(i=0;i<DateLen;i++) //ȡ
	  {
	     RxDate[i]=NRFSPI(0x00);//ȡĴָ
	  } 
    CSN=1;
   return(BackDate); 
}
/*****************SPIдTXFIFOĴֵ**********************************/
uchar NRFWriteTxDate(uchar RegAddr,uchar *TxDate,uchar DateLen)
{ //Ĵַ//дݴű//ȡݳ//ڷ
   uchar BackDate,i;
   CSN=0;
   BackDate=NRFSPI(RegAddr);//дҪдĴĵַ
   for(i=0;i<DateLen;i++)//д
     {
	    NRFSPI(*TxDate++);
	 }   
   CSN=1;
   return(BackDate);
}
/*****************NRFΪģʽ******************************/
void NRFSetTxMode(void)
{//ģʽ
    CE=0; 
   	NRFWriteTxDate(W_REGISTER+TX_ADDR,TX_ADDRESS,TX_ADDR_WITDH);//дĴָ+յַʹָ+յַ+ַ
	NRFWriteTxDate(W_REGISTER+RX_ADDR_P0,TX_ADDRESS,TX_ADDR_WITDH);//ΪӦ豸ͨ0ַͷ͵ַͬ//
	//NRFWriteTxDate(W_TX_PAYLOAD,TxDate,TX_DATA_WITDH);//д 
	/******йؼĴ**************/
  	NRFWriteReg(W_REGISTER+EN_AA,0x01);       // ʹܽͨ0ԶӦ//
  	NRFWriteReg(W_REGISTER+EN_RXADDR,0x01);   // ʹܽͨ0//
  	NRFWriteReg(W_REGISTER+SETUP_RETR,0x1f);  // Զطʱȴ250us+86usԶط10//
  	NRFWriteReg(W_REGISTER+RF_CH,40);         // ѡƵͨ0x40
  	NRFWriteReg(W_REGISTER+RF_SETUP,0x07);    // ݴ1Mbps书0dBmŴ//
	NRFWriteReg(W_REGISTER+CONFIG,0x0e);      // CRCʹܣ16λCRCУ飬ϵ,ģʽ  
	CE=1;
	Delay(5);//10us
}

/*****************NRFΪģʽ******************************/
void NRFSetRXMode()
{
	CE=0;
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P0, RX_ADDRESS0, RX_ADDR_WITDH);//дͨ0Ľյַ뷢͵ַͬ
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P1, RX_ADDRESS1, RX_ADDR_WITDH); //дͨ1Ľյַ
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P2, RX_ADDRESS2, 1);//дͨ2Ľյַ
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P3, RX_ADDRESS3, 1);//дͨ3Ľյַ
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P4, RX_ADDRESS4, 1);//дͨ4Ľյַ
	NRFWriteTxDate(W_REGISTER + RX_ADDR_P5, RX_ADDRESS5, 1);//дͨ5Ľյַ
	NRFWriteReg(W_REGISTER + RX_PW_P0, RX_DATA_WITDH);  // ͨ0ѡͷͨͬЧݿȣ32ֽڳ
  	NRFWriteReg(W_REGISTER + RX_PW_P1, RX_DATA_WITDH);
  	NRFWriteReg(W_REGISTER + RX_PW_P2, RX_DATA_WITDH);
  	NRFWriteReg(W_REGISTER + RX_PW_P3, RX_DATA_WITDH);
  	NRFWriteReg(W_REGISTER + RX_PW_P4, RX_DATA_WITDH);//
  	NRFWriteReg(W_REGISTER + RX_PW_P5, RX_DATA_WITDH);//
  	NRFWriteReg(W_REGISTER + EN_AA, 0x3f);       // ʹнͨԶӦ
  	NRFWriteReg(W_REGISTER + EN_RXADDR, 0x3f);   // ʹнͨ
	NRFWriteReg(W_REGISTER + RF_CH, 40);                 // ѡƵͨ0x40
	NRFWriteReg(W_REGISTER + RF_SETUP, 0x07);            // ݴ1Mbps书0dBmŴ
	NRFWriteReg(W_REGISTER + CONFIG, 0x0f);      // CRCʹܣ16λCRCУ飬ϵ
	//NRFWriteReg(W_REGISTER + SETUP_RETR, 0x0a);  // Զطʱȴ250us+86usԶط10
	CE=1;
	Delay(200);//10us
}

///******************жǷյݣӵʹRXȡ*********************/
//ڽģʽ
uchar NRFRevDate(uchar *RevDate)
{
	 sta=NRFReadReg(STATUS);//ݺȡ״̬Ĵ 	 
	 NRFWriteReg(W_REGISTER+STATUS,sta); //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ
     if(sta&RX_DR)				// жǷյ
	 {	
	    CE=0; 			//SPIʹ
		NRFReadRxDate(R_RX_PAYLOAD,RevDate,RX_DATA_WITDH);// RXFIFOȡ
		NRFWriteReg(FLUSH_RX,0xff);//RX FIFOĴ 
//		LED1=!LED1;
		return 1;
	  }
	 return 0;
}
//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
uchar NRFTxDate(uchar *TxDate)
{
	CE=0;
	NRFWriteTxDate(W_TX_PAYLOAD,TxDate,TX_DATA_WITDH);//д 
 	CE=1;//	   
	while(IRQ!=0);//ȴ
	sta=NRFReadReg(R_REGISTER+STATUS); 
	NRFWriteReg(W_REGISTER+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_RT)//ﵽط
	{
		NRFWriteReg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_RT; 
	}
	if(sta&TX_DS)//
	{
		return TX_DS;
	} 	

	return 0xff;//ԭʧ
}