#include "1602.h"
#include<stdio.h> //׼ 

sbit  RS = P2^0;   //H=data; L="command";    
sbit  RW = P2^1;   //H=read; L="write";
sbit  E = P2^2;   //input enable;


 /******************************************************************/
/*                    ΢ʱ                                */
/******************************************************************/
void DelayUs(unsigned char us)//delay us
{
 unsigned char uscnt;
 uscnt=us>>1;        /*12MHzƵ*/
 while(--uscnt);
}
/******************************************************************/
/*                    뺯                                */
/******************************************************************/
void DelayMs(unsigned char ms)
{
 while(--ms)
   {
     DelayUs(250);
     DelayUs(250);
	 DelayUs(250);
	 DelayUs(250);
   }
}

//ʾʼ
void LCD_init(void) 
{
	DelayMs(15);                           //ϵʱһʱ䣬ʹȶ
	Write_Instruction(0x38);				//8bit interface,2line,5*7dots
	DelayMs(5);
	Write_Instruction(0x38);	
	DelayMs(5);
	Write_Instruction(0x38);	

	Write_Instruction(0x08);	//ʾԹ꣬겻˸
	Write_Instruction(0x01);	//
	DelayMs(5);
	
	Write_Instruction(0x06);	//дһַַָӣʾƶ
	//Write_Instruction(0x05);	//дһַ
	//Write_Instruction(0x04);	//дһַַָʾƶ
	//Write_Instruction(0x07);	//дһַ
	DelayMs(5);
	
	//Write_Instruction(0x0B);	//رʾʾַֻб
	Write_Instruction(0x0C);	//ʾꡢ˸ر
	//Write_Instruction(0x0D);	//ʾʾ꣬˸
	//Write_Instruction(0x0E);	//ʾʾ꣬겻˸
	//Write_Instruction(0x0F);	//ʾꡢ˸ʾ
}

//LCDдʱ
void LCD_en_write(void)        //EN˲һߵƽ壬LCDдʱ
  {
    E=1;
    DelayUs(20);
    E=0;
	DelayUs(20);
  }
  
//
void LCD_clear(void)
{
  Write_Instruction(0x01);
  DelayMs(5);
}
  
//дָ
void Write_Instruction(uchar command)
{
  RS=0;
  RW=0;
  E=1;
  P0=command;
  LCD_en_write();//дָ
}

//дݺ
void Write_Data(uchar Wdata)
{
  RS=1;
  RW=0;
  E=1;
  P0=Wdata;
  LCD_en_write();//д
}

//ַʾʼַ
void LCD_SET_XY(uchar X,uchar Y)
{
  uchar address;
  if(Y==0)
    address=0x80+X;//Y=0,ʾڵһʾַΪ0x80
  else 
    address=0xc0+X;//Y0ʱʱڵڶʾַΪ0XC0
  Write_Instruction(address);//дָʾʼַ
}

//ڵXYпʼʾָ*Sַָ
void LCD_write_str(uchar X,uchar Y,uchar *s)
{
  LCD_SET_XY(X,Y);//óʼַʾַ
  while(*s)//дʾֱַһַ"/0"
  {
    Write_Data(*s);//д뵱ǰַʾ
	s++;//ַָ1ָһдַ
  }
}

//ڵXYпʼʾWdataӦĵַ
void LCD_write_char(uchar X,uchar Y,uchar Wdata)
{
  LCD_SET_XY(X,Y);//дַ
  Write_Data(Wdata);//д뵱ǰַʾ
}